Package org.zkoss.stateless.sul

## Interface IStepbar

- All Superinterfaces:
    `IAnyGroup<IStepbar>`, `IChildable<IStepbar,​IStep>`, `IComponent<IStepbar>`, `IHtmlBasedComponent<IStepbar>`, `IXulElement<IStepbar>`

      public interface IStepbar
      extends IXulElement<IStepbar>, IChildable<IStepbar,​IStep>, IAnyGroup<IStepbar>

  Immutable `Stepbar` component

  A stepbar. Shows several steps that represent sequential navigation.

  ### Support @Action

  Name | Action Type
  --- | ---
  onChange
  Represents an action caused by a user's selection changed at the client, the value can be received from `RequestData.getData()` with the key `"activeIndex"`

  Author:
    katherine
  See Also:
    `Stepbar`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IStepbar.Builder` | Builds instances of type `IStepbar`.
    `static class` | `IStepbar.Updater` | Builds an updater of type `IStepbar` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IStepbar` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default int` | `getActiveIndex()` | Return the index of the active step.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default boolean` | `isLinear()` | Returns whether the steps in this stepbar are displayed by order.
    `default boolean` | `isWrappedLabels()` | Returns whether the labels in children steps is wrapped.
    `static IStepbar` | `of​(java.lang.Iterable<? extends IStep> children)` | Returns the instance with the given `IStep` children.
    `static IStepbar` | `of​(IStep... children)` | Returns the instance with the given `IStep` children.
    `static IStepbar` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `IStepbar` | `withActiveIndex​(int activeIndex)` | Returns a copy of `this` immutable component with the specified `activeIndex`.
    `IStepbar` | `withLinear​(boolean linear)` | Returns a copy of `this` immutable component with the specified `linear`.
    `IStepbar` | `withWrappedLabels​(boolean wrappedLabels)` | Returns a copy of `this` immutable component with the specified `wrappedLabels`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IStepbar DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.wgt.Stepbar"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IStepbar>`

    - #### isWrappedLabels

          default boolean isWrappedLabels()

      Returns whether the labels in children steps is wrapped.

      Default: `false`.

    - #### withWrappedLabels

          IStepbar withWrappedLabels​(boolean wrappedLabels)

      Returns a copy of `this` immutable component with the specified `wrappedLabels`.

      Sets whether the labels in children steps is wrapped.

      Parameters:
        `wrappedLabels` - Whether the labels in children steps is wrapped.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### isLinear

          default boolean isLinear()

      Returns whether the steps in this stepbar are displayed by order.

      Default: `true`.

    - #### withLinear

          IStepbar withLinear​(boolean linear)

      Returns a copy of `this` immutable component with the specified `linear`.

      Sets whether the steps in this stepbar are displayed by order

      Parameters:
        `linear` - Whether the steps in this stepbar are displayed by order

        Default: `true`.

      Returns:
        A modified copy of the `this` object

    - #### getActiveIndex

          default int getActiveIndex()

      Return the index of the active step.

      Default: `0`.

    - #### withActiveIndex

          IStepbar withActiveIndex​(int activeIndex)

      Returns a copy of `this` immutable component with the specified `activeIndex`.

      Sets the index of the active step.

      Parameters:
        `activeIndex` - The index of the active step.

        Default: `0`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IStepbar of​(java.lang.Iterable<? extends IStep> children)

      Returns the instance with the given `IStep` children.
      Parameters:
        `children` - The children of `IStep`

    - #### of

          static IStepbar of​(IStep... children)

      Returns the instance with the given `IStep` children.
      Parameters:
        `children` - The children of `IStep`

    - #### ofId

          static IStepbar ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component